<template>
  <cabinet-layout nav-active="profile">
    <div
      slot="block-content"
      class="wrench">
      <submenu item-active="notification-setup"/>
      <div class="ui form">
        <div class="container">
          <div class="title-mobile">Настройки. Уведомления</div>
          <div class="title">Перечень возможных рассылок, на которые можно как подписаться, так и отписаться.</div>
          <div class="list">
            <NotificationItem
              ref="forms"
              v-for="(item, index) in notifications"
              :item="item"
              :key="'param-'+index"
              :index="index"
              @checkbox-changed="checkboxChanged"
              @inner-checkbox-changed="innerCheckboxChanged"
              @valid-additional="onCheckValidationState"
            />
          </div>
          <div
            v-if="auth.isOrganization"
            class="block-info">
            <div class="text">Уведомления о загрузке прайса для каждого филиала приходят на почту, указанную при
            настройке автозагрузки.
            </div>
            <div class="text">Уведомления об отзывах о филиале и уведомления о заказах/запросах в конкретный филиал
            приходят на почту, указанную при заполнении данных о филиале.
            </div>
            <div class="text">Уведомления об отзывах и запросах/заказах, сделанных филиалом, приходят на почту,
            указанную в форме отправки.
            </div>
          </div>
          <div class="block-btn">
            <button
              type="submit"
              :class="{loading: loading}"
              :disabled="disabled"
              @click="submit"
              class="ui button yellow btn-save-change"
            >Сохранить изменения
            </button>
          </div>
        </div>
      </div>
    </div>
    <div slot="line-modal">
      <exit-save
        @save="saveViaModal"
        :link="goToPath"
        :has-errors="disabled"
        v-model="modals.exitSave"/>
    </div>
  </cabinet-layout>
</template>

<script>
import CabinetLayout from '~/components/redesign/cabinet/main-layout';
import Submenu from '~/components/redesign/cabinet/submenu';
import Multiselect from 'vue-multiselect';
import watcherForProps from '~/assets/js/mixins/watcherForProps';
import ExitSave from '~/components/redesign/cabinet/modal/exit-save';
import NotificationItem from '~/components/redesign/cabinet/notification-item';
import { createNamespacedHelpers } from 'vuex';

const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'WrenchNotificationSetup',
  components: {
    CabinetLayout,
    NotificationItem,
    Submenu,
    Multiselect,
    ExitSave,
  },
  mixins: [
    watcherForProps(['notifications'], { deep: true }),
  ],
  layout: 'cabinet',
  async asyncData({ app, store }) {
    if (!store.state.user.auth) return {};
    const notifications = await app.$axios
      .$get('/_main/user/getNotificationSetup')
      .catch((error) => { console.error(error); });

    return {
      notifications: (notifications && notifications.data) || [],
    };
  },
  data() {
    return {
      errors: {},
      goToPath: '',
      loading: false,
      modals: {
        exitSave: false,
      },
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    hasErrors() {
      return Object.values(this.errors).some(el => el);
    },
    disabled() {
      return !this.isPropChanged || this.hasErrors;
    },
  },
  head() {
    return {
      title: 'Личный кабинет - Настройка - Настройка уведомлений',
    };
  },
  mounted() {
    document.addEventListener('mousedown', this.onLeaveBeforeSave);
  },
  destroyed() {
    document.removeEventListener('mousedown', this.onLeaveBeforeSave);
  },
  methods: {
    onLeaveBeforeSave(e) {
      const link = e.target.closest('a');

      if (!link) {
        return;
      }
      if (link.target === '_blank') {
        return;
      }
      if (this.isPropChanged) {
        this.exitSaveAction();
        this.goToPath = link.pathname;
      }
    },
    async send() {
      this.loading = true;
      return this.$axios.$post('/_main/user/setupNotification', {
        notificationList: this.notifications,
      })
        .then(res => res.data.success)
        .catch((e) => {
          console.error(e);
          return false;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    async saveViaModal() {
      if (this.hasErrors) {
        this.modals.exitSave = false;
      } else {
        const sendingResult = await this.send();
        if (sendingResult) {
          // @todo раскомментить, когда будут готовы все разделы на фронтапе
          // this.$router.push({ path: this.goToPath });
          window.location.href = this.goToPath;
          this.goToPath = '';
        }
      }
    },
    async submit() {
      if (this.hasErrors) {
        this.modals.exitSave = false;
      } else {
        const sendingResult = await this.send();
        if (sendingResult) {
          // @todo раскомментить, когда будут готовы разделы на фронтапе использовать this.$router.push
          window.location.href = this.auth.isOrganization
            ? '/cabinet/wrench/organization-info'
            : '/cabinet/wrench/notification-setup';
        }

        // @todo раскомментить, когда будут готовы разделы на фронтапе
        // auth.isOrganization
        //   ? this.$router.push({ path: '/cabinet/wrench/organization-info' })
        //   : this.$router.push({ path: '/cabinet/wrench/notification-setup' });
        this.modals.exitSave = false;
      }
    },

    checkboxChanged(payload) {
      this.notifications[payload.index].mainMail = payload.checked;
      this.notifications[payload.index].additionalMailSwitch = payload.checked;
      this.notifications[payload.index].mainSwitch = payload.checked;
    },

    onCheckValidationState(payload) {
      this.$set(this.errors, payload.notificationId, payload.hasError);
    },

    innerCheckboxChanged(payload) {
      this.notifications[payload.index][payload.type] = payload.checked;
      this.notifications[payload.index].mainSwitch = this.notifications[payload.index].mainMail
        || this.notifications[payload.index].additionalMailSwitch;
    },

    exitSaveAction() {
      this.modals.exitSave = true;
    },
  },

};
</script>

<style lang="postcss">
  .question {
    @media screen and (max-width: 980px) {
      display: none;
    }
    @media screen and (min-width: 981px) {
      position: relative;
      display: inline-flex;
      > .button {
        display: inline-flex;
        justify-content: center;
        align-items: center;
        width: 1rem;
        height: 1rem;
        background: transparent;
        border: 1px solid #9badb9;
        border-radius: 50%;
        outline: 0;
        cursor: pointer;
        &:before {
          display: inline-flex;
          content: "?";
          font-size: 0.75rem;
          font-weight: normal;
          line-height: 1;
          color: #4272a4;
        }
      }
    }
  }

  .wrench {
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: stretch;
    width: 100%;
    .container {
      display: flex;
      flex-flow: column nowrap!important;
      justify-content: flex-start;
      align-items: flex-start;
      padding: 1.5rem;
      @media screen and (max-width: 980px) {
        padding: 1.5rem 1rem;
      }
      .title-mobile {
        @media screen and (max-width: 980px) {
          display: block;
          font-size: 1.125rem;
          font-weight: 700;
          padding: 0 0 1.5rem;
        }
        @media screen and (min-width: 981px) {
          display: none;
        }
      }
      .title {
        display: block;
        line-height: 1.3;
        font-weight: 400;
        color: #6a7b87;
        padding: 0 0 1rem;
        margin: 0;
        @media screen and (max-width: 980px) {
          font-size: 1rem;
        }
        @media screen and (min-width: 981px) {
          font-size: 0.875rem;
        }
      }
      .list {
        display: flex;
        flex-flow: column nowrap;
        justify-content: flex-start;
        align-items: stretch;
        max-width: 100%;
      }
      .block-info {
        padding: 1.5rem 0 0;
        .text {
          display: block;
          font-size: 0.8125rem;
          line-height: 1.5;
          font-weight: 400;
          @media screen and (max-width: 980px) {
            padding-bottom: 0.5rem;
          }
        }
      }

      .block-btn {
        display: block;
        width: 100%;
        .btn-save-change {
          @media screen and (max-width: 980px) {
            width: 100%;
            max-width: 22rem;
            margin-top: 1.5rem;
          }
          @media screen and (min-width: 981px) {
            margin-top: 1.5rem;
            font-size: 0.875rem;
          }
        }
      }
    }
  }
</style>
